// TvvO

#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d10.lib")
#pragma comment(lib, "d3dx10.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d10.h>
#include <d3dx10.h>
#include "oxcp.h"
#include "stlparser.h"
#include "oxnumericcounter.h"


using namespace OX;

int wheelCount_g = 0;

struct Vtx {
	float x, y, z;
	float nx, ny, nz;
};

TCHAR gName[ 100 ] = _T( "ffʐ}`TvvO" );

LRESULT CALLBACK WndProc( HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam ) {
	switch ( mes ) {
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;
	case WM_MOUSEWHEEL: {
		bool bShift = GET_KEYSTATE_WPARAM( wParam ) & MK_SHIFT;
		wheelCount_g += GET_WHEEL_DELTA_WPARAM( wParam ) / WHEEL_DELTA;
		break;
	}
	case WM_CHAR:
		break;
	}
	return DefWindowProc( hWnd, mes, wParam, lParam );
}

int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	// STL
	std::string parseFileName;
	STLParser parser;
	if ( strlen( lpCmdLine ) > 0 ) {
		parseFileName = lpCmdLine;
	}
	else {
		parseFileName = "forest_dragon_full.stl";
		//parseFileName = "tetra.stl";
	}
	if ( parser.parseFromFile( parseFileName.c_str() ) == false ) {
		MessageBoxA( 0, "STLt@C܂łB", "STLt@CG[", 0 );
		return -1;
	}
	AABB aabb = parser.calcAABB();

	auto vertices = parser.getVertices();
	auto verticesSize = parser.getVerticesSize();
	auto indices = parser.getIndices();

	// AvP[V̏
	MSG msg; HWND hWnd;
	WNDCLASSEX wcex = { sizeof( WNDCLASSEX ), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
		(HBRUSH)( COLOR_WINDOW + 1 ), NULL, (TCHAR*)gName, NULL };
	if ( !RegisterClassEx( &wcex ) )
		return 0;

	int w = 800, h = 800;
	RECT clientRect = { 0, 0, w, h };
	::AdjustWindowRect( &clientRect, WS_OVERLAPPEDWINDOW, FALSE );

	if ( !( hWnd = CreateWindow( gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0,
		clientRect.right - clientRect.left, clientRect.bottom - clientRect.top,
		NULL, NULL, hInstance, NULL ) ) )
		return 0;

	ShowWindow( hWnd, nCmdShow );


	// Direct3D10̏ //
	cp< ID3D10Device > cpDevice_;
	cp< IDXGISwapChain > cpSwapChain_;
	cp< ID3D10RenderTargetView > cpRenderTargetView_;

	// Xbv`FCƃfoCX̏
	{
		DXGI_SWAP_CHAIN_DESC desc;
		memset( &desc, 0, sizeof( desc ) );
		desc.BufferCount = 1;
		desc.BufferDesc.Width = w;
		desc.BufferDesc.Height = h;
		desc.BufferDesc.Format = DXGI_FORMAT_R16G16B16A16_FLOAT;	// _eNX`ɂȂƖOaĂ܂
		desc.BufferDesc.Scaling = DXGI_MODE_SCALING_UNSPECIFIED;
		desc.BufferDesc.RefreshRate.Numerator = 60;
		desc.BufferDesc.RefreshRate.Denominator = 1;
		desc.BufferDesc.ScanlineOrdering = DXGI_MODE_SCANLINE_ORDER_UNSPECIFIED;
		desc.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
		desc.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;
		desc.OutputWindow = hWnd;
		desc.SampleDesc.Count = 1;
		desc.SampleDesc.Quality = 0;
		desc.SwapEffect = DXGI_SWAP_EFFECT_DISCARD;
		desc.Windowed = TRUE;

		if ( FAILED( D3D10CreateDeviceAndSwapChain(
			0,
			D3D10_DRIVER_TYPE_HARDWARE,
			0,
			0,
			D3D10_SDK_VERSION,
			&desc,
			cpSwapChain_.toCreator(),
			cpDevice_.toCreator()
		) ) ) {
			return false;
		}
	}

	// obNobt@m
	ID3D10Texture2D *backBuffer;
	if ( FAILED( cpSwapChain_->GetBuffer( 0, __uuidof( ID3D10Texture2D ), (void**)&backBuffer ) ) ) {
		return false;
	}

	cp< ID3D10RenderTargetView > backBufferRenderTargetView_;
	if ( FAILED( cpDevice_->CreateRenderTargetView( backBuffer, 0, backBufferRenderTargetView_.toCreator() ) ) ) {
		return false;
	}
	cpDevice_->OMSetRenderTargets( 1, backBufferRenderTargetView_.getPtrPtr(), 0 );	// o̓}[Wɐݒ

	// kxXeVobt@쐬
	cp< ID3D10Texture2D > depthStencil;
	D3D10_TEXTURE2D_DESC dstDesc;
	dstDesc.Width = w;
	dstDesc.Height = h;
	dstDesc.MipLevels = 1;
	dstDesc.ArraySize = 1;
	dstDesc.Format = DXGI_FORMAT_D32_FLOAT;
	dstDesc.SampleDesc.Count = 1;
	dstDesc.SampleDesc.Quality = 0;
	dstDesc.Usage = D3D10_USAGE_DEFAULT;
	dstDesc.BindFlags = D3D10_BIND_DEPTH_STENCIL;
	dstDesc.CPUAccessFlags = 0;
	dstDesc.MiscFlags = 0;
	cpDevice_->CreateTexture2D( &dstDesc, 0, depthStencil.toCreator() );

	cp< ID3D10DepthStencilView > dsView;
	D3D10_DEPTH_STENCIL_VIEW_DESC dsvDesc;
	dsvDesc.Format = dstDesc.Format;
	dsvDesc.ViewDimension = D3D10_DSV_DIMENSION_TEXTURE2D;
	dsvDesc.Texture2D.MipSlice = 0;
	cpDevice_->CreateDepthStencilView( depthStencil.getPtr(), &dsvDesc, dsView.toCreator() );

	// r[|[gݒ
	D3D10_VIEWPORT vp;
	vp.TopLeftX = 0;
	vp.TopLeftY = 0;
	vp.Width = w;
	vp.Height = h;
	vp.MinDepth = 0.0f;
	vp.MaxDepth = 1.0f;

	// _obt@
	D3D10_BUFFER_DESC vtxBufDesc;
	vtxBufDesc.Usage = D3D10_USAGE_DEFAULT;
	vtxBufDesc.ByteWidth = verticesSize;
	vtxBufDesc.BindFlags = D3D10_BIND_VERTEX_BUFFER;
	vtxBufDesc.CPUAccessFlags = 0;
	vtxBufDesc.MiscFlags = 0;

	D3D10_SUBRESOURCE_DATA vtxData;
	memset( &vtxData, 0, sizeof( vtxData ) );
	vtxData.pSysMem = &vertices[ 0 ];

	cp< ID3D10Buffer > vtxBuffer;
	cpDevice_->CreateBuffer( &vtxBufDesc, &vtxData, vtxBuffer.toCreator() );

	// ̓CAEg
	D3D10_INPUT_ELEMENT_DESC layout[] = {
		{ "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0 },
		{ "TEXCOORD", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0 }
	};

	// CfbNXobt@
	D3D10_BUFFER_DESC idxBufDesc;
	memset( &idxBufDesc, 0, sizeof( idxBufDesc ) );
	idxBufDesc.Usage = D3D10_USAGE_DEFAULT;
	idxBufDesc.ByteWidth = indices.size() * sizeof( uint32_t );
	idxBufDesc.BindFlags = D3D10_BIND_INDEX_BUFFER;

	D3D10_SUBRESOURCE_DATA idxData;
	memset( &idxData, 0, sizeof( idxData ) );
	idxData.pSysMem = &indices[ 0 ];

	cp< ID3D10Buffer > idxBuffer;
	cpDevice_->CreateBuffer( &idxBufDesc, &idxData, idxBuffer.toCreator() );

	// GtFNg
	cp< ID3D10Effect > effect;
	ID3D10Blob *err = 0;
	auto res = D3DX10CreateEffectFromFile( "sectionsurface.fx", 0, 0, "fx_4_0", D3D10_SHADER_ENABLE_STRICTNESS, 0, cpDevice_.getPtr(), 0, 0, effect.toCreator(), &err, 0 );;
	if ( FAILED( res ) ) {
		const char* errStr = (const char*)err->GetBufferPointer();
		return 0;
	}

	cp< ID3D10InputLayout > vtxLayout;
	ID3D10EffectTechnique *tech = effect->GetTechniqueByName( "tech" );
	ID3D10EffectPass *pass = tech->GetPassByIndex( 0 );
	D3D10_PASS_DESC passDesc;
	pass->GetDesc( &passDesc );
	cpDevice_->CreateInputLayout( layout, 2, passDesc.pIAInputSignature, passDesc.IAInputSignatureSize, vtxLayout.toCreator() );

	float clearColor[ 4 ] = { 0.0f, 0.0f, 0.0f, 1.0f };
	float yLevel = 0.0f;

	// IuWFNg̒__ɈړAX-90x]nʂɐݒu
	D3DXMATRIX world, rotXMat, offsetCenterMat, placeXZMat;
	float rotX = D3DXToRadian( -90.0f );
	D3DXMatrixRotationX( &rotXMat, rotX );
	AABB worldAABB = aabb.rot( AABB::Axis_X );
	D3DXMatrixTranslation( &offsetCenterMat, -aabb.center_.x, -aabb.center_.y, -aabb.center_.z );
	world = offsetCenterMat * rotXMat;
	world._42 += worldAABB.halfLen3_.y;

	float yLevelMin = 0.0f;
	float yLevelMax = worldAABB.halfLen3_.y * 2.0f;
	float cameraY = yLevelMax + 1.0f;	// JYʒu
	float yUnit = ( yLevelMax - yLevelMin ) / 200.0f;
	yLevelMin = yUnit;

	float orthoWidth = 2.0f * ( worldAABB.halfLen3_.x > worldAABB.halfLen3_.z ? worldAABB.halfLen3_.x : worldAABB.halfLen3_.z );
	float orthoHeight = orthoWidth;

	int ref = 0;
	
	// bZ[W [v
	do {
		if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else {
			// esݒ
			D3DXMATRIX view, proj;
			D3DXMatrixLookAtLH( &view, &D3DXVECTOR3( 0.0f, cameraY, 0.0f ), &D3DXVECTOR3( 0.0f, 0.0f, 0.0f ), &D3DXVECTOR3( 0.0f, 0.0f, 1.0f ) );
			D3DXMatrixOrthoLH( &proj, orthoWidth, orthoHeight, 0.1f, yLevelMax + 2.0f );

			// Direct3D̏
			cpDevice_->RSSetViewports( 1, &vp );
			cpDevice_->OMSetRenderTargets( 1, backBufferRenderTargetView_.getPtrPtr(), dsView.getPtr() );

			cpDevice_->ClearRenderTargetView( backBufferRenderTargetView_.getPtr(), clearColor );
			cpDevice_->ClearDepthStencilView( dsView.getPtr(), D3D10_CLEAR_DEPTH, 1.0f, 0 );

			// yLevelXV
			yLevel += wheelCount_g * yUnit;
			if ( yLevel > yLevelMax ) {
				yLevel = yLevelMax;
				ref++;
			}
			else if ( yLevel < yLevelMin ) {
				yLevel = yLevelMin;
				ref++;
			}
			wheelCount_g = 0;

			// f̗ʂZ`
			UINT stride = sizeof( STLParser::Vertex );
			UINT offset = 0;
			cpDevice_->IASetVertexBuffers( 0, 1, vtxBuffer.getPtrPtr(), &stride, &offset );
			cpDevice_->IASetIndexBuffer( idxBuffer.getPtr(), DXGI_FORMAT_R32_UINT, 0 );
			cpDevice_->IASetInputLayout( vtxLayout.getPtr() );
			cpDevice_->IASetPrimitiveTopology( D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

			D3DXMATRIX wvp = world * view * proj;
			auto worldV = effect->GetVariableByName( "world" );
			worldV->AsMatrix()->SetMatrix( (float*)&world );
			auto wvpV = effect->GetVariableByName( "wvp" );
			wvpV->AsMatrix()->SetMatrix( (float*)wvp );

			auto yLevelV = effect->GetVariableByName( "yLevel" );
			yLevelV->AsScalar()->SetFloat( yLevel );

			tech->GetPassByName( "BackfaceDraw" )->Apply( 0 );
			cpDevice_->DrawIndexed( indices.size(), 0, 0 );

			// f̕\ʂZ`
			tech->GetPassByName( "FrontfaceDraw" )->Apply( 0 );
			cpDevice_->DrawIndexed( indices.size(), 0, 0 );

			// Xbv
			cpSwapChain_->Present( 1, 0 );
		}
	} while ( msg.message != WM_QUIT );

	cpDevice_->ClearState();

	return 0;
}